Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# IdeSceneObject Class Reference

`#include <deScene.hpp>`

Inheritance diagram for IdeSceneObject:

[legend]
Collaboration diagram for IdeSceneObject:

[legend]
List of all members.

## Public Types
enum | activate_t { activate_visible = 0, activate_collide = 1, activate_count, activate_32bit = 0x7fffffff }
enum | interface_t { iface_IdeSceneObject = 0, iface_IdeSceneStaticMesh = 1, iface_IdeSceneSky = 2, iface_IdeSceneTerrain = 3, iface_IdeSceneABT = 4, iface_IdeSceneAnimatedMesh = 5, iface_IdeSceneActor = 6, iface_IdeSceneLight = 7, iface_32Bit = 0x7fffffff }
## Public Member Functions
virtual IdeSceneObject::interface_t | GetSOIType ()=0
virtual void * | GetSOInterface (IdeSceneObject::interface_t i)=0
virtual void | PreCache (IdeDriver *pDriver)=0
virtual long | Traverse (IdeSceneGraph::deSceneTraversal *Params)=0
virtual void | SetActivation (activate_t a_type, deBoolean Active)=0
| Set the activation state of the object.
virtual deBoolean | GetActivation (activate_t a_type) const=0
| Retrieve the activation state of the object.
virtual void | GetWorldTransform (deTransformInfo &mat)=0
virtual void | SetWorldTransform (const deTransformInfo &mat)=0
| set the world transformation of this object
virtual void | GetLocalAABB (deAABB &bbox)=0
| retrieve the local AABB (computed as the extents of the object on its local axes)
virtual void | GetWorldOBB (deOBB &bbox)=0
| retrieve the oriented bounding box in world coordinates (local AABB transformed into world space)
virtual void | GetWorldAABB (deAABB &bbox)=0
virtual deVec3d | GetBoundCenter ()=0
virtual deVec3d | GetOccludeCenter ()=0
virtual void | GetWorldPos (deVec3d &PosVector)=0
virtual deVec3d | GetWorldBoundCenter ()=0
virtual deVec3d | GetWorldOccludeCenter ()=0
virtual deDouble | GetBoundRadius ()=0
virtual deDouble | GetOccludeRadius ()=0
virtual deBoolean | IsTransparent ()=0
virtual deBoolean | OccludesObject (deVec3d &position, IdeSceneObject *so, deVec3d &NormalizedDisplacement)=0
virtual long | GetCurrentPassNum () const=0
virtual deBoolean | AddRoomReference (IdeSceneRoom *ref, void *ptr)=0
virtual void * | GetRoomReference (IdeSceneRoom *ref)=0
virtual deBoolean | RemoveRoomReference (IdeSceneRoom *ref)=0
## Protected Member Functions
virtual | ~IdeSceneObject ()

## Detailed Description

A base class for dealing with Scene Objects. A scene object occupies the space that is defined by scene rooms. Related functions: IdeSceneObject_GetWOInterfaceID.

## Member Enumeration Documentation

enum IdeSceneObject::activate_t

  | Enumeration values:
  activate_visible |
  activate_collide |
  activate_count |
  activate_32bit |

enum IdeSceneObject::interface_t

  | Enumeration values:
  iface_IdeSceneObject |
  iface_IdeSceneStaticMesh |
  iface_IdeSceneSky |
  iface_IdeSceneTerrain |
  iface_IdeSceneABT |
  iface_IdeSceneAnimatedMesh |
  iface_IdeSceneActor |
  iface_IdeSceneLight |
  iface_32Bit |

## Constructor & Destructor Documentation

virtual IdeSceneObject::~IdeSceneObject | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

virtual deBoolean IdeSceneObject::AddRoomReference | ( | IdeSceneRoom * | ref,
|  | void * | ptr
| ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual deBoolean IdeSceneObject::GetActivation | ( | activate_t | a_type | ) | const`[pure virtual]`

| Retrieve the activation state of the object. Implemented in deSceneObject.

virtual deVec3d IdeSceneObject::GetBoundCenter | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual deDouble IdeSceneObject::GetBoundRadius | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual long IdeSceneObject::GetCurrentPassNum | ( |  | ) | const`[pure virtual]`

| Implemented in deSceneObject.

virtual void IdeSceneObject::GetLocalAABB | ( | deAABB & | bbox | ) | `[pure virtual]`

| retrieve the local AABB (computed as the extents of the object on its local axes) Implemented in deSceneObject.

virtual deVec3d IdeSceneObject::GetOccludeCenter | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual deDouble IdeSceneObject::GetOccludeRadius | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual void* IdeSceneObject::GetRoomReference | ( | IdeSceneRoom * | ref | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual void* IdeSceneObject::GetSOInterface | ( | IdeSceneObject::interface_t | i | ) | `[pure virtual]`

| Implemented in deSceneObject, deSceneABT, deSceneTerrain, deSceneSky, deSceneAnimatedMesh, deSceneStaticMesh, deSceneActor, and deSceneLight.

virtual IdeSceneObject::interface_t IdeSceneObject::GetSOIType | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject, deSceneABT, deSceneTerrain, deSceneSky, deSceneAnimatedMesh, deSceneStaticMesh, deSceneActor, and deSceneLight.

virtual void IdeSceneObject::GetWorldAABB | ( | deAABB & | bbox | ) | `[pure virtual]`

| retrieve the world AABB of the object. This AABB is guaranteed to contain the world OBB for the current orientation, and may contain the OBB no matter what its orientation. Implemented in deSceneObject.

virtual deVec3d IdeSceneObject::GetWorldBoundCenter | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual void IdeSceneObject::GetWorldOBB | ( | deOBB & | bbox | ) | `[pure virtual]`

| retrieve the oriented bounding box in world coordinates (local AABB transformed into world space) Implemented in deSceneObject.

virtual deVec3d IdeSceneObject::GetWorldOccludeCenter | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual void IdeSceneObject::GetWorldPos | ( | deVec3d & | PosVector | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual void IdeSceneObject::GetWorldTransform | ( | deTransformInfo & | mat | ) | `[pure virtual]`

| retrieve the world transformation of this object. All bounding volumes are relative to the translation of this Implemented in deSceneObject.

virtual deBoolean IdeSceneObject::IsTransparent | ( |  | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual deBoolean IdeSceneObject::OccludesObject | ( | deVec3d & | position,
|  | IdeSceneObject * | so,
|  | deVec3d & | NormalizedDisplacement
| ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual void IdeSceneObject::PreCache | ( | IdeDriver * | pDriver | ) | `[pure virtual]`

| Implemented in deSceneObject, and deSceneTerrain.

virtual deBoolean IdeSceneObject::RemoveRoomReference | ( | IdeSceneRoom * | ref | ) | `[pure virtual]`

| Implemented in deSceneObject.

virtual void IdeSceneObject::SetActivation | ( | activate_t | a_type,
|  | deBoolean | Active
| ) | `[pure virtual]`

| Set the activation state of the object. Implemented in deSceneObject.

virtual void IdeSceneObject::SetWorldTransform | ( | const deTransformInfo & | mat | ) | `[pure virtual]`

| set the world transformation of this object Implemented in deSceneObject, and deSceneLight.

virtual long IdeSceneObject::Traverse | ( | IdeSceneGraph::deSceneTraversal * | Params | ) | `[pure virtual]`

| Implemented in deSceneObject.

The documentation for this class was generated from the following file:

- deScene.hpp